{*******************************************************}
{                                                       }
{       Turbo Pascal Version 7.0                        }
{       FreePacal                                       }
{       Delphi 4                                        }
{    Standart error handler for console application     }
{    without TV interface                               }
{                                                       }
{       Copyright (c) 1999 by Alexs                     }
{                                                       }
{*******************************************************}

{$IFDEF VER70}
{$O-}
{$ENDIF}
{$I Define.inc}

unit STD_EH;
interface

implementation
uses Ext_Sys, Ext_Math, Register;

function StdErrorMessage(MessageCode:TMessegeCode; Info:Pointer; Flags:word):word;far;
var C:char;
    S:string;
    R:word;
    L,i:integer;
    BC:integer;
    CC:array [1..4] of Word;
begin
  writeln(Titles[Flags and $03]);
  writeln(StdErrorString(MessageCode));
  S:='';
  BC:=0;
  for I := 0 to 3 do
    if Flags and ($0100 shl I) <> 0 then
    begin
      inc(BC);
      S:=S+IntToStr(BC)+' '+ButtonName[I]+', ';
      CC[BC]:=Commands[i];
    end;
  if S<>'' then
  begin
    S:='('+Copy(S,1,Length(S)-2)+')';
    R:=0;
    repeat
      write(S);
      readln(C);
      if (C in ['1'..'4']) then
      begin
        L:=StrToInt(C);
        if (L>0) and (L<BC+1) then R:=CC[L];
      end;
    until (R<>0);
  end else R:=cmCancel;
  StdErrorMessage:=R;
end;

begin
  if @ErrorMessage=@DefErrorMessage then
{$IFDEF FPC}
  ErrorMessage:=@StdErrorMessage;
{$ELSE}
  ErrorMessage:=StdErrorMessage;
{$ENDIF}
end.

